<?php

namespace App\Database\Migrations;

use CodeIgniter\Database\Migration;
use CodeIgniter\Database\RawSql;

class OrdenTrabajoTableFilesTable extends Migration
{
    protected array $COLUMNS = [
        "id" => [
            "type" => "INT",
            "unsigned" => true,
            "auto_increment" => true
        ],
        "orden_trabajo_id" => [
            "type" => "INT",
            "unsigned" => true,
        ],
        "name" => [
            "type" => "TEXT",
        ],
        "upload_by" => [
            "type" => "INT",
            "unsigned" => true,
            "constraint" => 10,
        ],
        "file_path" => [
            "type" => "TEXT",
        ]
    ];

    public function up()
    {
        $this->forge->addField($this->COLUMNS);
        $currenttime = new RawSql("CURRENT_TIMESTAMP");
        $this->forge->addField([
            "created_at" => [
                "type" => "TIMESTAMP",
                "default" => $currenttime,

            ],
            "updated_at" => [
                "type" => "TIMESTAMP",
                "null" => true,

            ],
            "deleted_at" => [
                "type" => "TIMESTAMP",
                "null" => true,
            ],
        ]);
        $this->forge->addPrimaryKey("id");
        $this->forge->addForeignKey("upload_by", "users", "id","CASCADE","CASCADE");
        $this->forge->addForeignKey("orden_trabajo_id", "ordenes_trabajo", "id","CASCADE","CASCADE");
        $this->forge->createTable("orden_trabajo_files", true);
    }

    public function down()
    {
        $this->forge->dropTable("orden_trabajo_files");
    }
}
